/*
 * Least Cost Routing plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#ifndef __LCRCFG_H
#define __LCRCFG_H

#ifdef LCR_DEBUG
#define Dprintf(x...) printf(x);
#else
#define Dprintf(x...) ;
#endif

enum eLcrModes
{
  eLcrModeBasic,
  eLcrModeTransponder,
  eLcrModeStream,
  eLcrModeAC3,
  eLcrModeMaxNumber
};

struct cLcrConfig
{
public:
  cLcrConfig(void);
  int hidemenu;
  int displaymode;
  int theme;
  int redlimit;
  int greenlimit;
  int updateinterval;
  int analyzestream;
  int calcinterval;
  int syslogoutput;
  int showcasystem;
  int osdheight;
  int osdoffsetX;
  int osdoffsetY;
  int zoomIn;
  int logoFrame;
};

extern cLcrConfig lcrConfig;

enum eLcrThemes
{
  eLcrThemeClassic,
  eLcrThemeElchi,
  eLcrThemeDeepBlue,
  eLcrThemeMoronimo,
  eLcrThemeMaxNumber
};

struct cLcrTheme
{
  int clrBackground;
  int clrTitleBackground;
  int clrTitleText;
  int clrActiveText;
  int clrInactiveText;
  int clrRed;
  int clrYellow;
  int clrGreen;
};

extern const cLcrTheme lcrTheme[eLcrThemeMaxNumber];

#endif // __LCRCFG_H
