/*
 * Least Cost Routing plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#include "lcri18n.h"

const tI18nPhrase Phrases[] = {
  { "Displays telephone rates on OSD", // English
    "Zeigt Telefontarife auf OSD an", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Least Cost Routing", // English
    "Billiger telefonieren", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Source", // English
    "Quelle", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Loading tariff data", // English
    "Lade Tarifdaten", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "basic", // English
    "Standard", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais 
    "", // Norsk
    "perus", // suomi
    "", // Polski   
    "", // Espaol  
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar  
    "", // Catal  
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "standard", // Eesti
    "", // Dansk
  },
  { "City", // English
    "Ort", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais 
    "", // Norsk
    "", // suomi
    "", // Polski   
    "", // Espaol  
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar  
    "", // Catal  
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Near", // English
    "Nah", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais 
    "", // Norsk
    "", // suomi
    "", // Polski   
    "", // Espaol  
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar  
    "", // Catal  
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Nat.", // English
    "Fern", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais 
    "", // Norsk
    "", // suomi
    "", // Polski   
    "", // Espaol  
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar  
    "", // Catal  
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "D1", // English
    "D1", // Deutsch
    "D1", // Slovenski
    "D1", // Italiano
    "D1", // Nederlands
    "D1", // Portugus
    "D1", // Franais 
    "D1", // Norsk
    "D1", // suomi
    "D1", // Polski   
    "D1", // Espaol  
    "D1", //  (Greek)
    "D1", // Svenska
    "D1", // Romaneste
    "D1", // Magyar  
    "D1", // Catal  
    "D1", //  (Russian)
    "D1", // Hrvatski (Croatian)
    "D1", // Eesti
    "D1", // Dansk
  },
  { "D2", // English
    "D2", // Deutsch
    "D2", // Slovenski
    "D2", // Italiano
    "D2", // Nederlands
    "D2", // Portugus
    "D2", // Franais 
    "D2", // Norsk
    "D2", // suomi
    "D2", // Polski   
    "D2", // Espaol  
    "D2", //  (Greek)
    "D2", // Svenska
    "D2", // Romaneste
    "D2", // Magyar  
    "D2", // Catal  
    "D2", //  (Russian)
    "D2", // Hrvatski (Croatian)
    "D2", // Eesti
    "D2", // Dansk
  },
  { "E-Plus", // English
    "E-Plus", // Deutsch
    "E-Plus", // Slovenski
    "E-Plus", // Italiano
    "E-Plus", // Nederlands
    "E-Plus", // Portugus
    "E-Plus", // Franais 
    "E-Plus", // Norsk
    "E-Plus", // suomi
    "E-Plus", // Polski   
    "E-Plus", // Espaol  
    "E-Plus", //  (Greek)
    "E-Plus", // Svenska
    "E-Plus", // Romaneste
    "E-Plus", // Magyar  
    "E-Plus", // Catal  
    "E-Plus", //  (Russian)
    "E-Plus", // Hrvatski (Croatian)
    "E-Plus", // Eesti
    "E-Plus", // Dansk
  },
  { "O2", // English
    "O2", // Deutsch
    "O2", // Slovenski
    "O2", // Italiano
    "O2", // Nederlands
    "O2", // Portugus
    "O2", // Franais 
    "O2", // Norsk
    "O2", // suomi
    "O2", // Polski   
    "O2", // Espaol  
    "O2", //  (Greek)
    "O2", // Svenska
    "O2", // Romaneste
    "O2", // Magyar  
    "O2", // Catal  
    "O2", //  (Russian)
    "O2", // Hrvatski (Croatian)
    "O2", // Eesti
    "O2", // Dansk
  },
  { "Price", // English
    "Preis", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais 
    "", // Norsk
    "", // suomi
    "", // Polski   
    "", // Espaol  
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar  
    "", // Catal  
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Pulse", // English
    "Takt", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais 
    "", // Norsk
    "", // suomi
    "", // Polski   
    "", // Espaol  
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar  
    "", // Catal  
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Classic", // English
    "Klassischer", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais 
    "", // Norsk
    "Klassinen", // suomi
    "", // Polski   
    "", // Espaol  
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar  
    "", // Catal  
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "Klassikaline", // Eesti
    "", // Dansk
  },
  { "Elchi", // English
    "Elchi", // Deutsch
    "Elchi", // Slovenski
    "Elchi", // Italiano
    "Elchi", // Nederlands
    "Elchi", // Portugus
    "Elchi", // Franais 
    "Elchi", // Norsk
    "Elchi", // suomi
    "Elchi", // Polski   
    "Elchi", // Espaol  
    "Elchi", //  (Greek)
    "Elchi", // Svenska
    "Elchi", // Romaneste
    "Elchi", // Magyar  
    "Elchi", // Catal  
    "Elchi", //  (Russian)
    "Elchi", // Hrvatski (Croatian)
    "Elchi", // Eesti
    "Elchi", // Dansk
  },
  { "DeepBlue", // English
    "DeepBlue", // Deutsch
    "DeepBlue", // Slovenski
    "DeepBlue", // Italiano
    "DeepBlue", // Nederlands
    "DeepBlue", // Portugus
    "DeepBlue", // Franais 
    "DeepBlue", // Norsk
    "DeepBlue", // suomi
    "DeepBlue", // Polski   
    "DeepBlue", // Espaol  
    "DeepBlue", //  (Greek)
    "DeepBlue", // Svenska
    "DeepBlue", // Romaneste
    "DeepBlue", // Magyar  
    "DeepBlue", // Catal  
    "DeepBlue", //  (Russian)
    "DeepBlue", // Hrvatski (Croatian)
    "DeepBlue", // Eesti
    "DeepBlue", // Dansk
  },
  { "Moronimo", // English
    "Moronimo", // Deutsch
    "Moronimo", // Slovenski
    "Moronimo", // Italiano
    "Moronimo", // Nederlands
    "Moronimo", // Portugus
    "Moronimo", // Franais 
    "Moronimo", // Norsk
    "Moronimo", // suomi
    "Moronimo", // Polski   
    "Moronimo", // Espaol  
    "Moronimo", //  (Greek)
    "Moronimo", // Svenska
    "Moronimo", // Romaneste
    "Moronimo", // Magyar  
    "Moronimo", // Catal  
    "Moronimo", //  (Russian)
    "Moronimo", // Hrvatski (Croatian)
    "Moronimo", // Eesti
    "Moronimo", // Dansk
  },
  { "Frame around Logo", // English
    "Rahmen ums Logo", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Hide main menu entry", // English
    "Hauptmeneintrag verstecken", // Deutsch
    "", // Slovenski
    "Nascondi voce men", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "Piilota valinta pvalikosta", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "    ", //  (Russian)
    "", // Hrvatski (Croatian)
    "Peida valik peamens", // Eesti
    "", // Dansk
  },
  { "Horizontal offset", // English
    "Abstand links", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Vertical offset", // English
    "Abstand oben", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Zoom-in", // English
    "Reinzoomen", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Theme", // English
    "Aussehen", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "", // Eesti
    "", // Dansk
  },
  { "Video Format", // English
    "Bildformat", // Deutsch
    "", // Slovenski
    "", // Italiano
    "", // Nederlands
    "", // Portugus
    "", // Franais
    "", // Norsk
    "Kuvaformaatti", // suomi
    "", // Polski
    "", // Espaol
    "", //  (Greek)
    "", // Svenska
    "", // Romaneste
    "", // Magyar
    "", // Catal
    "", //  (Russian)
    "", // Hrvatski (Croatian)
    "Videoformaat", // Eesti
    "", // Dansk
  },
  { "PAL", // English
    "PAL", // Deutsch
    "PAL", // Slovenski
    "PAL", // Italiano
    "PAL", // Nederlands
    "PAL", // Portugus
    "PAL", // Franais
    "PAL", // Norsk
    "PAL", // suomi
    "PAL", // Polski
    "PAL", // Espaol
    "PAL", //  (Greek)
    "PAL", // Svenska
    "PAL", // Romaneste
    "PAL", // Magyar
    "PAL", // Catal
    "PAL", //  (Russian)
    "PAL", // Hrvatski (Croatian)
    "PAL", // Eesti
    "PAL", // Dansk
  },
  { "NTSC", // English
    "NTSC", // Deutsch
    "NTSC", // Slovenski
    "NTSC", // Italiano
    "NTSC", // Nederlands
    "NTSC", // Portugus
    "NTSC", // Franais
    "NTSC", // Norsk
    "NTSC", // suomi
    "NTSC", // Polski
    "NTSC", // Espaol
    "NTSC", //  (Greek)
    "NTSC", // Svenska
    "NTSC", // Romaneste
    "NTSC", // Magyar
    "NTSC", // Catal
    "NTSC", //  (Russian)
    "NTSC", // Hrvatski (Croatian)
    "NTSC", // Eesti
    "NTSC", // Dansk
  },
  { NULL }
};
