#ifndef __MENUNET
#define __MENUNET

/*
 *(C) 2004 by Sebastian Ortwein <kron@animeland.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <getopt.h>
#include <stdlib.h>
#include <vdr/plugin.h>
#include <vdr/osd.h>
#include <vdr/menuitems.h>

#include "setup.h"


// --- cMenuEditIP ---------------------------------------------------------

class cMenuEditIP : public cOsdItem {
private:
  char *name;
  char *valuea;
  char *valueb;
  char *valuec;
  char *valued;
public:
  cMenuEditIP(const char *Name);
  ~cMenuEditIP();
  void SetValue(const char *Valuea,const char *Valueb,const char *Valuec,const char *Valued);
  };

// --- cMenuEditIntIP ------------------------------------------------------

class cMenuEditIntIP : public cMenuEditIP {
protected:
  int *valuea;
  int *valueb;
  int *valuec;
  int *valued;
  int editpos;
  int neweditpos;
  int min, max;
  int newValue ;
  virtual void Set(void);
public:
  cMenuEditIntIP(const char *Name, int *Valuea, int *Valueb, int *Valuec, int *Valued);
  virtual eOSState ProcessKey(eKeys Key);
  };

// --- cMenuSetupNetwork ---------------------------------------------------

class cMenuSetupNetwork : public cMenuSetupPage {
private:
  virtual void Set(void);
  cNetworkSetup data;
protected:
  virtual void Store(void);
public:
  cMenuSetupNetwork(void);
  virtual eOSState ProcessKey(eKeys Key);
};



#endif 
