/*
 * network.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id$
 */

#include <getopt.h>
#include <stdlib.h>
#include <vdr/plugin.h>

#include "menu.h"
#include "setup.h"
#include "i18n.h"

static const char *VERSION        = "0.0.1";
static const char *DESCRIPTION    = "Netzwerksetup";
static const char *MAINMENUENTRY  = "Network";

class cPluginNetwork : public cPlugin {
private:
  // Add any member variables or functions you may need here.
public:
  cPluginNetwork(void);
  virtual ~cPluginNetwork();
  virtual const char *Version(void) { return VERSION; }
  virtual const char *Description(void) { return DESCRIPTION; }
  virtual const char *CommandLineHelp(void);
  virtual bool ProcessArgs(int argc, char *argv[]);
  virtual bool Initialize(void);
  virtual bool Start(void);
  virtual void Housekeeping(void);
// virtual const char *MainMenuEntry(void) { return MAINMENUENTRY; }
  virtual cOsdObject *MainMenuAction(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual bool SetupParse(const char *Name, const char *Value);
  };

cPluginNetwork::cPluginNetwork(void)
{
  // Initialize any member variables here.
  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
}


cPluginNetwork::~cPluginNetwork()
{
  // Clean up after yourself!
}

const char *cPluginNetwork::CommandLineHelp(void)
{
  // Return a string that describes all known command line options.
  return NULL;
}

bool cPluginNetwork::ProcessArgs(int argc, char *argv[])
{
  return true;
}

bool cPluginNetwork::Initialize(void)
{
  // Initialize any background activities the plugin shall perform.
  return true;
}

bool cPluginNetwork::Start(void)
{
  // Start any background activities the plugin shall perform.
  i18n_name=Name();
  RegisterI18n(Phrases);
  return true;
}

void cPluginNetwork::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

cOsdObject *cPluginNetwork::MainMenuAction(void)
{
  // Perform the action when selected from the main VDR menu.
  return NULL;
}

cMenuSetupPage *cPluginNetwork::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return new cMenuSetupNetwork;
}

bool cPluginNetwork::SetupParse(const char *Name, const char *Value)
{
  // Parse your own setup parameters and store their values.
  return true;
}

VDRPLUGINCREATOR(cPluginNetwork); // Don't touch this!
