/*
 * PhotoCD plugin for VDR
 * pcd_setup.h: Setup the plugin
 *
 * See the README file for copyright information and how to reach the author.
 *
 * This code is distributed under the terms and conditions of the
 * GNU GENERAL PUBLIC LICENSE. See the file COPYING for details.
 *
 */


#ifndef __PCD_SETUP_H
#define __PCD_SETUP_H

#include <vdr/menuitems.h>
#include "pcd_func.h"

class cPcdSetupData {
public:
  int DriveSpeed;
  int HideMainMenuEntry;
  int Quality;
  int Pal;
  int QuickScaling;
  int NoAdjust;
  int SlideInterval;
public:
  cPcdSetupData(void);
  };

class cPcdSetupMenu : public cMenuSetupPage {
private:
  cPCD *pcd;
  cPcdSetupData setupData;
protected:
  virtual void Store(void);
public:
  cPcdSetupMenu(cPCD *Pcd);
  };

extern cPcdSetupData PcdSetupData;

#endif //__PCD_SETUP_H
